!
  PROGRAM vair2cdf
!
  IMPLICIT NONE
!
! Este programa convierte ficheros Vairmer SO (2D) y VO (3D) ORCA
! en Netcdf
!
  INCLUDE 'netcdf.inc'
!
  INTEGER              :: ificid
  INTEGER              :: ijpiodimid, ijpjodimid, ijpkodimid
  INTEGER              :: il_timedimid, il_timeid
  INTEGER, DIMENSION(3):: ivardim
  INTEGER, DIMENSION(4):: ivardim3d
  INTEGER  :: itorcid(20)
  INTEGER  :: iforcid, iforcid2, i_error
  INTEGER  :: iat42id, iat42id2, ibt42id, ibt42id2, kstatus 
!
  INTEGER              :: jpio, jpjo, jpko, il_nb_file
  INTEGER              :: il_status, il_isoncid
  INTEGER              :: il_Varid, il_tini, il_tfin
  INTEGER              :: il_Dimid
  INTEGER              :: il_calendar
!
  character(len=8)         :: cl_fldnamT, cl_grdnamT, cl_dateT, cl_expnamT
  character(len=2)         :: cl_2d3dT
!
  REAL(kind=4), DIMENSION(:,:), allocatable            :: rl_Field_4
  REAL(kind=8), DIMENSION(:,:), allocatable            :: rl_Field_8
  REAL(kind=4), DIMENSION(:,:,:), allocatable          :: rl_Field_3d_4
  REAL(kind=8), DIMENSION(:,:,:), allocatable          :: rl_Field_3d_8
!
  INTEGER, DIMENSION(3)  :: il_Field_start
  INTEGER, DIMENSION(4)  :: il_Field_start_3d
  INTEGER, DIMENSION(3)  :: il_Field_count
  INTEGER, DIMENSION(4)  :: il_Field_count_3d
!
  character(len=100)        :: cT_VairmerFileName
!
  INTEGER                :: eof_champ, eof_fichero, il_champ, il_fichero
  INTEGER                :: il_kind, il_date_ini, il_dia, il_meso
  INTEGER                :: il_ano, il_units, il_date_cur
  INTEGER                :: il_monofield, il_test, il_step
  REAL(kind=8)           :: dl_units
  character(len=30)      :: cl_NetcdfFileName
  character(len=19)      :: cl_time_origin 
  character(len=33)      :: cl_units 
  character(len=7)       :: cl_convert
  character(len=3)       :: cl_nc
  character(len=2)       :: cl_freq
  character(len=2)       :: cl_freq_nc
  character(len=6)       :: cl_freq_nombre
  character(len=8)       :: cl_monofield
  INTEGER, EXTERNAL      :: if_diff_jours, if_diff_mois, if_diff_an, if_conv
  INTEGER, EXTERNAL      :: if_diff_jours_noleap

!
!  Lectura del fichero de parametros
!
!
 read(*,'(I5,X,I4,X,I4,X,I8,X,A2,X,A8,X,I1,X,I2)') jpio, jpjo, jpko, il_date_ini, cl_freq, cl_monofield, il_calendar, il_step
!   
!  Lectura del fichero Vairmer
!
 OPEN(UNIT=21,FILE='ficheros.txt', form='formatted')
 il_fichero=0
 read(21, '(A100)', iostat=eof_fichero) cT_VairmerFileName
 do while ( eof_fichero == 0 )
!   
  OPEN(UNIT=20,FILE=cT_VairmerFileName, form='unformatted')
  read(20,iostat=eof_champ) cl_fldnamT, cl_grdnamT, cl_dateT, cl_expnamT
!
!  Allocacion 
!
  if (il_fichero.eq.0 ) then
!
  print *, ' Grid Type: ', cl_grdnamT
  print *, ' Initial Date: ',cl_dateT 
!
    if (jpko.eq.0) then
      allocate(  rl_Field_8(jpio, jpjo) )
      allocate(  rl_Field_4(jpio, jpjo) )
      read(20,iostat = i_error) rl_Field_8
      if (i_error.ne.0) then
        deallocate(rl_Field_8)
        rewind(20)
        read(20) cl_fldnamT, cl_grdnamT, cl_dateT, cl_expnamT
        read(20,iostat = i_error) rl_Field_4
        if (i_error.ne.0) then
          print *, 'Wrong dimensions ', jpio, jpjo
          stop
        endif
        il_kind=4
        print *, '2D grid, simple precision',  jpio, jpjo
      else
        il_kind=8
        print *, '2D grid, double precision',  jpio, jpjo
      endif
    else
      allocate(  rl_Field_3d_8(jpio, jpjo, jpko) )
      allocate(  rl_Field_3d_4(jpio, jpjo, jpko) )
      read(20,iostat = i_error) rl_Field_3d_8
      if (i_error.ne.0) then
        deallocate(rl_Field_3d_8)
        rewind(20)
        read(20) cl_fldnamT, cl_grdnamT, cl_dateT, cl_expnamT
        read(20,iostat = i_error) rl_Field_3d_4
        if (i_error.ne.0) then
          print *, 'Wrong dimensions ', jpio, jpjo, jpko
          stop
        endif
        il_kind=4
        print *, '3D grid, simple precision',  jpio, jpjo, jpko
      else
        il_kind=8
        print *, '3D grid, double precision',  jpio, jpjo, jpko
      endif
    endif
! 
!
! Escala de tiempo
!
    if ( cl_freq == "DA" ) then
      cl_freq_nc="1d"
      il_ano=il_date_ini/10000
      il_meso=il_date_ini/100-il_ano*100
      il_dia=il_date_ini-il_meso*100-il_ano*10000
      il_units=0
      WRITE(cl_time_origin,'(i4,"-",i2.2,"-",i2.2," 00:00:00")') il_ano,il_meso,il_dia
      WRITE(cl_units,'("days since ",i4,"-",i2.2,"-",i2.2," 00:00:00")') il_ano,il_meso,il_dia
    elseif ( cl_freq .eq. "MO" .or. cl_freq .eq. "SE" .or. cl_freq .eq. "MA" .or. cl_freq .eq. "SA" ) then
      cl_freq_nc="1m"
      il_ano=il_date_ini/100
      il_meso=il_date_ini-il_ano*100
      il_units=0
      WRITE(cl_time_origin,'(i4,"-",i2.2,"-15 00:00:00")') il_ano,il_meso
      WRITE(cl_units,'("months since ",i4,"-",i2.2,"-15 00:00:00")') il_ano,il_meso
    elseif ( cl_freq .eq. "MS" .or. cl_freq .eq. "SN" ) then
      cl_freq_nc="1s"
      il_ano=il_date_ini/100
      il_meso=il_date_ini-il_ano*100
      il_units=0
      WRITE(cl_time_origin,'(i4,"-",i2.2,"-15 00:00:00")') il_ano,il_meso
      WRITE(cl_units,'("months since ",i4,"-",i2.2,"-15 00:00:00")') il_ano,il_meso
    elseif ( cl_freq .eq. "AN" ) then
      cl_freq_nc="1y"
      il_ano=il_date_ini
      il_units=0
      WRITE(cl_time_origin,'(i4,"-07-01 00:00:00")') il_ano
      WRITE(cl_units,'("years since ",i4,"-07-01 00:00:00")') il_ano
    endif
!
!  Fichero Netcdf
!
!
!  Mono field mode
!
    if ( cl_monofield .ne. "XXXXXXXX" ) then
      cl_fldnamT=cl_monofield
    endif
!    
    cl_convert="convert"
    cl_nc=".nc"
!
!  print *, cl_convert,cl_fldnamT,cl_grdnamT,cl_freq_nc,cl_nc
!
    WRITE(cl_NetcdfFileName,'(A7,A8,A8,"_",A2,"_",A3)') cl_convert,cl_fldnamT,cl_grdnamT,cl_freq_nc,cl_nc
! -> Create the file
    CALL hdlerr(NF_CREATE(cl_NetcdfFileName, 0, ificid))
!  PRINT *, 'ificid=', ificid
! -> Create dimensions
    CALL hdlerr(NF_DEF_DIM(ificid, 'x', jpio, ijpiodimid))
!  PRINT *, 'ijpiodimid=', ijpiodimid
    CALL hdlerr(NF_DEF_DIM(ificid, 'y', jpjo, ijpjodimid))
!  PRINT *, 'ijpjodimid=', ijpjodimid
    if ( jpko .gt. 0 ) then
      CALL hdlerr(NF_DEF_DIM(ificid, 'z', jpko, ijpkodimid))
!  PRINT *, 'ijpkodimid', ijpkodimid
    endif
    call hdlerr(NF_DEF_DIM(ificid, 'time_counter', NF_UNLIMITED, il_timedimid))
!
! -> Create variables
    ivardim(1)=ijpiodimid
    ivardim(2)=ijpjodimid
    ivardim(3)=il_timedimid
    call hdlerr(NF_DEF_VAR (ificid, 'time_counter',NF_DOUBLE,1,il_timedimid,il_timeid))
    call hdlerr(NF_PUT_ATT_TEXT (ificid, il_timeid, 'units', 32, cl_units))
    call hdlerr(NF_PUT_ATT_TEXT (ificid, il_timeid, 'title', 4, 'Time'))
    call hdlerr(NF_PUT_ATT_TEXT (ificid, il_timeid, 'long_name', 9, 'Time axis'))
    call hdlerr(NF_PUT_ATT_TEXT (ificid, il_timeid, 'time_origin', 19,cl_time_origin))
    if ( il_calendar .eq. 1 ) then
      call hdlerr(NF_PUT_ATT_TEXT (ificid, il_timeid, 'calendar',9,'gregorian'))
    elseif ( il_calendar .eq. 2 ) then
      call hdlerr(NF_PUT_ATT_TEXT (ificid, il_timeid, 'calendar',6,'julian'))
    elseif ( il_calendar .eq. 3 ) then
      call hdlerr(NF_PUT_ATT_TEXT (ificid, il_timeid, 'calendar',6,'noleap'))
    else
      print *,'Unknowned calendar'
      stop
    endif
!  
    il_champ=1
    REWIND 20
    read(20,iostat=eof_champ) cl_fldnamT, cl_grdnamT, cl_dateT, cl_expnamT
    do while ( eof_champ == 0 )
! Mono field mode
      if ( cl_monofield .ne. "XXXXXXXX" ) then
        if ( cl_monofield .ne. cl_fldnamT ) then
          if ( jpko .eq. 0 ) read(20) rl_Field_4
          if ( jpko .ne. 0 ) read(20) rl_Field_3d_4
          read(20,iostat=eof_champ) cl_fldnamT, cl_grdnamT, cl_dateT, cl_expnamT
          cycle
        endif
      else
! Multi field mode
        if ( jpko .eq. 0 ) read(20) rl_Field_4
        if ( jpko .ne. 0 ) read(20) rl_Field_3d_4
      endif
!
      if ( jpko .eq. 0 ) then
!
        il_Field_start(1)=1
        il_Field_start(2)=1
        il_Field_start(3)=1
        il_Field_count(1)=jpio
        il_Field_count(2)=jpjo
        il_Field_count(3)=1
!
        CALL hdlerr(NF_DEF_VAR (ificid, cl_fldnamT, NF_FLOAT, 3, ivardim, itorcid(il_champ)))
      else
        il_Field_start_3d(1)=1
        il_Field_start_3d(2)=1
        il_Field_start_3d(3)=1
        il_Field_start_3d(4)=1
        il_Field_count_3d(1)=jpio
        il_Field_count_3d(2)=jpjo
        il_Field_count_3d(3)=jpko
        il_Field_count_3d(4)=1
        ivardim3d(1)=ijpiodimid
        ivardim3d(2)=ijpjodimid
        ivardim3d(3)=ijpkodimid
        ivardim3d(4)=il_timedimid
        CALL hdlerr(NF_DEF_VAR (ificid, cl_fldnamT, NF_FLOAT, 4, ivardim3d, itorcid(il_champ)))
      endif  
! Mono field mode
      if ( cl_monofield .ne. "XXXXXXXX" ) exit
!
      read(20,iostat=eof_champ) cl_fldnamT, cl_grdnamT, cl_dateT, cl_expnamT
! Lecture bidon
      print *,cl_fldnamT
      il_champ=il_champ+1
    enddo  
!! Leave DEFINE mode for oce2oas.nc netCDF Dataset
    call hdlerr(NF_ENDDEF(ificid))
! Mono field mode
      if ( cl_monofield .ne. 'XXXXXXXX' .and. cl_monofield .ne. cl_fldnamT) then
        print *, ' Field ', cl_monofield, ' not found'
        stop
      endif
!
  else
!
! Fin de las inicializaciones
!
! Determinacion de la fecha
!
!   paso definido
!
    if (il_step .ne. 0) then
        il_date_cur=0
!
!   paso leido
!
    else
        il_date_cur=if_conv(cl_dateT)
        il_step=1
    endif
!
    il_test=(il_date_cur/100)*100 - il_date_cur 
    if ( il_test .eq. 0 ) then
      il_date_cur = il_date_cur / 100
    else
      il_test=(il_date_cur/10000)*10000 - il_date_cur
      if ( il_test .eq. 0 ) il_date_cur = il_date_cur / 10000
    endif
    if ( il_date_cur .le. 0 ) then
      il_units=il_units+il_step
    else
      if ( cl_freq == "DA" ) then
        if ( il_calendar .eq. 1 ) then
          il_units=if_diff_jours(il_date_cur,il_date_ini)
        elseif ( il_calendar .eq. 2 ) then
           print *, 'Julian calendar not yet implemented'
           stop
!          il_units=if_diff_jours_julian(il_date_cur,il_date_ini)
        elseif ( il_calendar .eq. 3 ) then
          il_units=if_diff_jours_noleap(il_date_cur,il_date_ini)
        endif
      elseif ( cl_freq .eq. "MO" .or. cl_freq .eq. "SE" .or. cl_freq .eq. "MA" .or. cl_freq .eq. "SA" ) then
        il_units=if_diff_mois(il_date_cur,il_date_ini)
      elseif ( cl_freq .eq. "MS" .or. cl_freq .eq. "SN" ) then
        il_units=if_diff_mois(il_date_cur,il_date_ini)
      elseif ( cl_freq .eq. "AN" ) then
        il_units=if_diff_an(il_date_cur,il_date_ini)
      endif
    endif    
  endif
!
! Lectura de los campos para cada fichero
!
  il_champ=1
  if ( il_units .le. 0 .and. il_fichero .gt. 0 ) then
    print *, 'Date mismatch, check 3rd field of Vairmer file header', cT_VairmerFileName
    stop
  endif
!
  il_Field_start(3)=il_fichero+1
  il_Field_start_3d(4)=il_fichero+1
!
  dl_units=il_units
  call hdlerr(NF_PUT_VARA_DOUBLE (ificid, il_timeid, il_Field_start(3), 1, dl_units))
!  print *, 'Units', il_units
  REWIND 20
  read(20,iostat=eof_champ) cl_fldnamT, cl_grdnamT, cl_dateT, cl_expnamT
  do while ( eof_champ == 0 )
!    
! Mono field mode
    if ( cl_monofield .ne. "XXXXXXXX" ) then
      if ( cl_monofield .ne. cl_fldnamT ) then
        if ( jpko .eq. 0 ) read(20) rl_Field_4
        if ( jpko .ne. 0 ) read(20) rl_Field_3d_4
        read(20,iostat=eof_champ) cl_fldnamT, cl_grdnamT, cl_dateT, cl_expnamT
        cycle
      endif
    endif
!
    if ( jpko .eq. 0 ) then
      if (il_kind.eq.8) then
        read(20) rl_Field_8
        rl_Field_4=rl_Field_8
      else 
        read(20) rl_Field_4
      endif
      call hdlerr(NF_PUT_VARA_REAL (ificid, itorcid(il_champ),il_Field_start,il_Field_count,rl_Field_4))
    else
      if (il_kind.eq.8) then
        read(20) rl_Field_3d_8
        rl_Field_3d_4=rl_Field_3d_8
      else 
        read(20) rl_Field_3d_4
      endif
      call hdlerr(NF_PUT_VARA_REAL (ificid, itorcid(il_champ),il_Field_start_3d,il_Field_count_3d,rl_Field_3d_4))
    endif
!
! Mono field mode
    if ( cl_monofield .ne. "XXXXXXXX" ) exit
!
    read(20,iostat=eof_champ) cl_fldnamT, cl_grdnamT, cl_dateT, cl_expnamT
    il_champ=il_champ+1
  enddo
!
  read(21,'(A100)', iostat=eof_fichero) cT_VairmerFileName
!  print *, 'cT_VairmerFileName', cT_VairmerFileName, eof_fichero
  il_fichero=il_fichero+1
!  
  enddo
!
! Close grids.nc netCDF Dataset
 kstatus = NF_CLOSE(ificid) 
!
 stop
 end
!
  subroutine hdlerr(istatus)
  integer                 :: istatus
  include 'netcdf.inc'
  if (istatus .ne. NF_NOERR) then
      print *, NF_STRERROR(istatus)
      stop 'stopped'
  endif
  return
  end

